#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define int long long

using namespace __gnu_pbds;
using namespace std;

template<class T>
using ordered_set = tree<T, null_type, std::less<T>, rb_tree_tag, tree_order_statistics_node_update>;

struct pr{
    int l, r, sum = 0;
};

const int N = 1e5;
vector<int> t(4 * N);
int n;
vector<int> vec;

void build(int v = 1, int tl = 0, int tr = n - 1) {
    if (tl == tr) {
        t[v] = vec[tl];
        return;
    }
    int tm = (tl + tr) / 2;
    build(2 * v, tl, tm);
    build(2 * v + 1, tm + 1, tr);
    t[v] = max(t[2 * v], t[2 * v + 1]);
}

int get(int l, int r, int v = 1, int tl = 0, int tr = n - 1) {
    if (max(l, tl) > min(r, tr)) {
        return -1;
    }
    if (l <= tl && tr <= r) {
        return t[v];
    }
    int tm = (tl + tr) / 2;
    return max(get(l, r, 2 * v, tl, tm), get(l, r, 2 * v + 1, tm + 1, tr));
}

void solve() {
    cin >> n;
    vec.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> vec[i];
    }
    build();
    vector<int> k(n - 1);
    vector<pr> seg(n);
    for (int i = 0; i < n; i++) {
        seg[i] = {i, i};
    }
    ordered_set<pair<int, int>> s;
    for (int i = 0; i < n - 1; i++) {
        cin >> k[i];
//        k[i] += s.order_of_key({k[i], -1});
//        s.insert({k[i], -1});
        k[i]--;
//        cout << k[i] << '\n';
    }
    for (int i = 0; i < n - 1; i++) {
        seg[k[i]].r = seg[k[i] + 1].r;
        for (int j = k[i] + 1; j < n - 1; j++) {
            seg[j] = seg[j + 1];
        }
        seg[k[i]].sum = 0;
        int l = seg[k[i]].l;
        int r = seg[k[i]].r;
        for (int v = l; v <= r; v++) {
            seg[k[i]].sum += min(get(l, v), get(v, r)) - vec[v];
        }
        cout << seg[k[i]].sum << '\n';
    }
}

signed main()
{
    // ios_base::sync_with_stdio(false);
    // cin.tie(nullptr);
    int z = 1;
    //    cin >> z;
    while (z--) {
        solve();
    }
}
