#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>


using namespace __gnu_pbds;

gp_hash_table<int, int> hmap;

template<class T>
using ordered_set = tree<T, null_type, std::less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define int long long

using namespace std;

bool is_sqrt(int n) {
    int l = 1, r = sqrt(n) + 1;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (m * m <= n) {
            l = m;
        } else {
            r = m;
        }
    }
    return (l * l == n);
}

void solve() {
    int d, l, r;
    cin >> d >> l >> r;
    int L = sqrt(l + d);
    int R = sqrt(r);
    int cnt = 0;
//    cout << L << '\n';
    for (int i = L; i <= R; i++) {
//        cout << i * i << ' ' << i * i - d << '\n';
        if (i * i < l || i * i - d < l) continue;
        if (is_sqrt(i * i - d)) {
//            cout << i * i << ' ' << i * i - d << '\n';
            cnt++;
        }
    }
    cout << cnt << '\n';
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int z = 1;
//    cin >> z;
    while (z--) {
        solve();
    }
}
