#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define int long long

using namespace __gnu_pbds;
using namespace std;

template<class T>
using ordered_set = tree<T, null_type, std::less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod = 1e9 + 7;

const int N = 1e5;

vector<int> f(N + 1);

void precalc() {
    f[0] = 1;
    for (int i = 1; i <= N; i++) {
        f[i] = f[i - 1] * i % mod;
    }
}

int binpow(int a, int n) {
    if (n == 1) {
        return a;
    }
    if (n == 0) {
        return 1;
    }
    if (n % 2 == 0) {
        int res = binpow(a, n / 2);
        return res * res % mod;
    }
    return a * binpow(a, n - 1) % mod;
}

int cnk(int n, int k) {
    return (f[n] * binpow(f[n - k], mod - 2) % mod) * binpow(f[k], mod - 2) % mod;
}

int calc(int n) {
    return (n * (n + 1)) / 2;
}

void solve() {
    precalc();
    int n, k;
    cin >> n >> k;
    vector<int> vec(n);
    for (auto &i : vec) {
        cin >> i;
    }
    for (int i = 0; i < n; i++) {
        if (i + 1 >= k && vec[i] > calc(k)) {
            cout << 0;
            return;
        } else {
            if (i + 1 < k && vec[i] > calc(k) - calc(k - i - 1)) {
                cout << 0;
                return;
            }
        }
    }
    if (k == 1) {
        cout << 1;
        return;
    }
    vector<vector<int>> ans((1 << k), vector<int> (n));
    if (k == 2) {
        for (int mask = 0; mask < (1 << k); mask++) {
            if (__builtin_popcount(mask) == vec[0]) {
                ans[mask][0]++;
            }
        }
        for (int i = 1; i < n; i++) {
            for (int mask1 = 0; mask1 < (1 << k); mask1++) {
                for (int mask2 = 0; mask2 < (1 << k); mask2++) {
                    int cnt = 0;
                    if ((mask1 & 1)) cnt++;
                    if ((mask2 & 1)) cnt++;
                    if ((mask2 & 2)) cnt++;
                    if (cnt == vec[i]) {
                        ans[mask2][i] += ans[mask1][i - 1];
                    }
                    ans[mask2][i] %= mod;
                }
            }
        }
        int cnt = 0;
        for (int i = 0; i < (1 << k); i++) {
            cnt += ans[i][n - 1];
        }
        cout << cnt << '\n';
    }
}

signed main()
{
    // ios_base::sync_with_stdio(false);
    // cin.tie(nullptr);
    int z = 1;
    //    cin >> z;
    while (z--) {
        solve();
    }
}
